'
'  pb_ini.bas
'  Ini File Manipulation routines
'
'  Public Domain Routies from
'  Don Dickinson
'  ddickinson@usinternet.com
'  dickinson.basicguru.com
'
#If Not %Def(%PB_INI_BAS)
%PB_INI_BAS = 1

#If Not %Def(%WINAPI)
#Include "win32api.inc"
#EndIf

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  GetIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function GetIni Alias "GetIni" _
      ( ByVal sFile As String, ByVal sSection As String, _
        ByVal sKey As String, ByVal sDefault As String ) Export As String

   Dim szString As Asciiz * 1000
   Dim szFile As Asciiz * 300
   Dim szSection As Asciiz * 300
   Dim szKey As Asciiz * 300
   Dim szDefault As Asciiz * 300

   szFile = sFile
   szSection = sSection
   szKey = sKey
   szDefault = sDefault
   GetPrivateProfileString szSection, szKey, szDefault, szString, 1000, szFile

   Function = Trim$(szString)

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  WriteIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub WriteIni Alias "WriteIni" _
      ( ByVal sFile As String, ByVal sSection As String, _
        ByVal sKey As String, ByVal sData As String) Export

   Dim zFile As Asciiz * 300
   Dim zSection As Asciiz * 300
   Dim zKey As Asciiz * 300
   Dim zData As Asciiz * 1000

   zFile = Trim$(sFile)
   zSection = Trim$(sSection)
   zKey = Trim$(sKey)
   zData = Trim$(sData)
   WritePrivateProfileString zSection, zKey, zData, zFile

End Sub


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  GetWinIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function GetWinIni Alias "GetWinIni" _
      ( ByVal sSection As String, ByVal sKey As String, _
        ByVal sDefault As String ) Export As String

   Function = GetIni("win.ini", sSection, sKey, sDefault)

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  WriteWinIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub WriteWinIni Alias "WriteWinIni" _
      ( ByVal sSection As String, ByVal sKey As String, _
        ByVal sData As String ) Export

   Dim zSection As Asciiz * 300
   Dim zKey As Asciiz * 300
   Dim zData As Asciiz * 1000
   zSection = Trim$(sSection)
   zKey = Trim$(sKey)
   zData = Trim$(sData)
   WriteProfileString zSection, zKey, zData
End Sub

#EndIf

